# coding: utf-8

"""
    VMware Aria Automation Assembler Blueprint API

    A multi-cloud Blueprint API for VMware Aria Automation Services  This page describes the RESTful APIs for Blueprint. The APIs facilitate CRUD operations on the various resources and entities used throughout Blueprint (Blueprints, Blueprint Terraform Integrations , PropertyGroups , etc.) and allow operations on them (creating a Blueprint, creating a Property group, etc.).  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across Blueprint entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/blueprint/api/blueprints?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/blueprint/api/blueprints?$top=10&$skip=2```   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PropertyDefinition(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'type': 'str',
        'encrypted': 'bool',
        'computed': 'bool',
        'recreate_on_update': 'bool',
        'ignore_on_update': 'bool',
        'ignore_case_on_diff': 'bool',
        'write_only': 'bool',
        'format': 'str',
        'minimum': 'float',
        'maximum': 'float',
        'items': 'PropertyDefinition',
        'min_items': 'int',
        'max_items': 'int',
        'min_properties': 'int',
        'max_properties': 'int',
        'unique_items': 'bool',
        'additional_properties': 'bool',
        'required': 'list[str]',
        '_not': 'PropertyDefinition',
        'any_of': 'list[PropertyDefinition]',
        'one_of': 'list[PropertyDefinition]',
        'all_of': 'list[PropertyDefinition]',
        'dependencies': 'dict(str, list[str])',
        'pattern': 'str',
        'max_length': 'int',
        'min_length': 'int',
        'title': 'str',
        'description': 'str',
        'properties': 'dict(str, PropertyDefinition)',
        'metadata': 'dict(str, object)',
        'default': 'object',
        'const': 'object',
        'ref': 'str',
        'data': 'str',
        'dynamic_default': 'str',
        'enum': 'list[object]'
    }

    attribute_map = {
        'type': 'type',
        'encrypted': 'encrypted',
        'computed': 'computed',
        'recreate_on_update': 'recreateOnUpdate',
        'ignore_on_update': 'ignoreOnUpdate',
        'ignore_case_on_diff': 'ignoreCaseOnDiff',
        'write_only': 'writeOnly',
        'format': 'format',
        'minimum': 'minimum',
        'maximum': 'maximum',
        'items': 'items',
        'min_items': 'minItems',
        'max_items': 'maxItems',
        'min_properties': 'minProperties',
        'max_properties': 'maxProperties',
        'unique_items': 'uniqueItems',
        'additional_properties': 'additionalProperties',
        'required': 'required',
        '_not': 'not',
        'any_of': 'anyOf',
        'one_of': 'oneOf',
        'all_of': 'allOf',
        'dependencies': 'dependencies',
        'pattern': 'pattern',
        'max_length': 'maxLength',
        'min_length': 'minLength',
        'title': 'title',
        'description': 'description',
        'properties': 'properties',
        'metadata': 'metadata',
        'default': 'default',
        'const': 'const',
        'ref': '$ref',
        'data': '$data',
        'dynamic_default': '$dynamicDefault',
        'enum': 'enum'
    }

    def __init__(self, type=None, encrypted=None, computed=None, recreate_on_update=None, ignore_on_update=None, ignore_case_on_diff=None, write_only=None, format=None, minimum=None, maximum=None, items=None, min_items=None, max_items=None, min_properties=None, max_properties=None, unique_items=None, additional_properties=None, required=None, _not=None, any_of=None, one_of=None, all_of=None, dependencies=None, pattern=None, max_length=None, min_length=None, title=None, description=None, properties=None, metadata=None, default=None, const=None, ref=None, data=None, dynamic_default=None, enum=None):  # noqa: E501
        """PropertyDefinition - a model defined in Swagger"""  # noqa: E501
        self._type = None
        self._encrypted = None
        self._computed = None
        self._recreate_on_update = None
        self._ignore_on_update = None
        self._ignore_case_on_diff = None
        self._write_only = None
        self._format = None
        self._minimum = None
        self._maximum = None
        self._items = None
        self._min_items = None
        self._max_items = None
        self._min_properties = None
        self._max_properties = None
        self._unique_items = None
        self._additional_properties = None
        self._required = None
        self.__not = None
        self._any_of = None
        self._one_of = None
        self._all_of = None
        self._dependencies = None
        self._pattern = None
        self._max_length = None
        self._min_length = None
        self._title = None
        self._description = None
        self._properties = None
        self._metadata = None
        self._default = None
        self._const = None
        self._ref = None
        self._data = None
        self._dynamic_default = None
        self._enum = None
        self.discriminator = None
        if type is not None:
            self.type = type
        if encrypted is not None:
            self.encrypted = encrypted
        if computed is not None:
            self.computed = computed
        if recreate_on_update is not None:
            self.recreate_on_update = recreate_on_update
        if ignore_on_update is not None:
            self.ignore_on_update = ignore_on_update
        if ignore_case_on_diff is not None:
            self.ignore_case_on_diff = ignore_case_on_diff
        if write_only is not None:
            self.write_only = write_only
        if format is not None:
            self.format = format
        if minimum is not None:
            self.minimum = minimum
        if maximum is not None:
            self.maximum = maximum
        if items is not None:
            self.items = items
        if min_items is not None:
            self.min_items = min_items
        if max_items is not None:
            self.max_items = max_items
        if min_properties is not None:
            self.min_properties = min_properties
        if max_properties is not None:
            self.max_properties = max_properties
        if unique_items is not None:
            self.unique_items = unique_items
        if additional_properties is not None:
            self.additional_properties = additional_properties
        if required is not None:
            self.required = required
        if _not is not None:
            self._not = _not
        if any_of is not None:
            self.any_of = any_of
        if one_of is not None:
            self.one_of = one_of
        if all_of is not None:
            self.all_of = all_of
        if dependencies is not None:
            self.dependencies = dependencies
        if pattern is not None:
            self.pattern = pattern
        if max_length is not None:
            self.max_length = max_length
        if min_length is not None:
            self.min_length = min_length
        if title is not None:
            self.title = title
        if description is not None:
            self.description = description
        if properties is not None:
            self.properties = properties
        if metadata is not None:
            self.metadata = metadata
        if default is not None:
            self.default = default
        if const is not None:
            self.const = const
        if ref is not None:
            self.ref = ref
        if data is not None:
            self.data = data
        if dynamic_default is not None:
            self.dynamic_default = dynamic_default
        if enum is not None:
            self.enum = enum

    @property
    def type(self):
        """Gets the type of this PropertyDefinition.  # noqa: E501


        :return: The type of this PropertyDefinition.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this PropertyDefinition.


        :param type: The type of this PropertyDefinition.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def encrypted(self):
        """Gets the encrypted of this PropertyDefinition.  # noqa: E501


        :return: The encrypted of this PropertyDefinition.  # noqa: E501
        :rtype: bool
        """
        return self._encrypted

    @encrypted.setter
    def encrypted(self, encrypted):
        """Sets the encrypted of this PropertyDefinition.


        :param encrypted: The encrypted of this PropertyDefinition.  # noqa: E501
        :type: bool
        """

        self._encrypted = encrypted

    @property
    def computed(self):
        """Gets the computed of this PropertyDefinition.  # noqa: E501


        :return: The computed of this PropertyDefinition.  # noqa: E501
        :rtype: bool
        """
        return self._computed

    @computed.setter
    def computed(self, computed):
        """Sets the computed of this PropertyDefinition.


        :param computed: The computed of this PropertyDefinition.  # noqa: E501
        :type: bool
        """

        self._computed = computed

    @property
    def recreate_on_update(self):
        """Gets the recreate_on_update of this PropertyDefinition.  # noqa: E501


        :return: The recreate_on_update of this PropertyDefinition.  # noqa: E501
        :rtype: bool
        """
        return self._recreate_on_update

    @recreate_on_update.setter
    def recreate_on_update(self, recreate_on_update):
        """Sets the recreate_on_update of this PropertyDefinition.


        :param recreate_on_update: The recreate_on_update of this PropertyDefinition.  # noqa: E501
        :type: bool
        """

        self._recreate_on_update = recreate_on_update

    @property
    def ignore_on_update(self):
        """Gets the ignore_on_update of this PropertyDefinition.  # noqa: E501


        :return: The ignore_on_update of this PropertyDefinition.  # noqa: E501
        :rtype: bool
        """
        return self._ignore_on_update

    @ignore_on_update.setter
    def ignore_on_update(self, ignore_on_update):
        """Sets the ignore_on_update of this PropertyDefinition.


        :param ignore_on_update: The ignore_on_update of this PropertyDefinition.  # noqa: E501
        :type: bool
        """

        self._ignore_on_update = ignore_on_update

    @property
    def ignore_case_on_diff(self):
        """Gets the ignore_case_on_diff of this PropertyDefinition.  # noqa: E501


        :return: The ignore_case_on_diff of this PropertyDefinition.  # noqa: E501
        :rtype: bool
        """
        return self._ignore_case_on_diff

    @ignore_case_on_diff.setter
    def ignore_case_on_diff(self, ignore_case_on_diff):
        """Sets the ignore_case_on_diff of this PropertyDefinition.


        :param ignore_case_on_diff: The ignore_case_on_diff of this PropertyDefinition.  # noqa: E501
        :type: bool
        """

        self._ignore_case_on_diff = ignore_case_on_diff

    @property
    def write_only(self):
        """Gets the write_only of this PropertyDefinition.  # noqa: E501


        :return: The write_only of this PropertyDefinition.  # noqa: E501
        :rtype: bool
        """
        return self._write_only

    @write_only.setter
    def write_only(self, write_only):
        """Sets the write_only of this PropertyDefinition.


        :param write_only: The write_only of this PropertyDefinition.  # noqa: E501
        :type: bool
        """

        self._write_only = write_only

    @property
    def format(self):
        """Gets the format of this PropertyDefinition.  # noqa: E501


        :return: The format of this PropertyDefinition.  # noqa: E501
        :rtype: str
        """
        return self._format

    @format.setter
    def format(self, format):
        """Sets the format of this PropertyDefinition.


        :param format: The format of this PropertyDefinition.  # noqa: E501
        :type: str
        """

        self._format = format

    @property
    def minimum(self):
        """Gets the minimum of this PropertyDefinition.  # noqa: E501


        :return: The minimum of this PropertyDefinition.  # noqa: E501
        :rtype: float
        """
        return self._minimum

    @minimum.setter
    def minimum(self, minimum):
        """Sets the minimum of this PropertyDefinition.


        :param minimum: The minimum of this PropertyDefinition.  # noqa: E501
        :type: float
        """

        self._minimum = minimum

    @property
    def maximum(self):
        """Gets the maximum of this PropertyDefinition.  # noqa: E501


        :return: The maximum of this PropertyDefinition.  # noqa: E501
        :rtype: float
        """
        return self._maximum

    @maximum.setter
    def maximum(self, maximum):
        """Sets the maximum of this PropertyDefinition.


        :param maximum: The maximum of this PropertyDefinition.  # noqa: E501
        :type: float
        """

        self._maximum = maximum

    @property
    def items(self):
        """Gets the items of this PropertyDefinition.  # noqa: E501


        :return: The items of this PropertyDefinition.  # noqa: E501
        :rtype: PropertyDefinition
        """
        return self._items

    @items.setter
    def items(self, items):
        """Sets the items of this PropertyDefinition.


        :param items: The items of this PropertyDefinition.  # noqa: E501
        :type: PropertyDefinition
        """

        self._items = items

    @property
    def min_items(self):
        """Gets the min_items of this PropertyDefinition.  # noqa: E501


        :return: The min_items of this PropertyDefinition.  # noqa: E501
        :rtype: int
        """
        return self._min_items

    @min_items.setter
    def min_items(self, min_items):
        """Sets the min_items of this PropertyDefinition.


        :param min_items: The min_items of this PropertyDefinition.  # noqa: E501
        :type: int
        """

        self._min_items = min_items

    @property
    def max_items(self):
        """Gets the max_items of this PropertyDefinition.  # noqa: E501


        :return: The max_items of this PropertyDefinition.  # noqa: E501
        :rtype: int
        """
        return self._max_items

    @max_items.setter
    def max_items(self, max_items):
        """Sets the max_items of this PropertyDefinition.


        :param max_items: The max_items of this PropertyDefinition.  # noqa: E501
        :type: int
        """

        self._max_items = max_items

    @property
    def min_properties(self):
        """Gets the min_properties of this PropertyDefinition.  # noqa: E501


        :return: The min_properties of this PropertyDefinition.  # noqa: E501
        :rtype: int
        """
        return self._min_properties

    @min_properties.setter
    def min_properties(self, min_properties):
        """Sets the min_properties of this PropertyDefinition.


        :param min_properties: The min_properties of this PropertyDefinition.  # noqa: E501
        :type: int
        """

        self._min_properties = min_properties

    @property
    def max_properties(self):
        """Gets the max_properties of this PropertyDefinition.  # noqa: E501


        :return: The max_properties of this PropertyDefinition.  # noqa: E501
        :rtype: int
        """
        return self._max_properties

    @max_properties.setter
    def max_properties(self, max_properties):
        """Sets the max_properties of this PropertyDefinition.


        :param max_properties: The max_properties of this PropertyDefinition.  # noqa: E501
        :type: int
        """

        self._max_properties = max_properties

    @property
    def unique_items(self):
        """Gets the unique_items of this PropertyDefinition.  # noqa: E501


        :return: The unique_items of this PropertyDefinition.  # noqa: E501
        :rtype: bool
        """
        return self._unique_items

    @unique_items.setter
    def unique_items(self, unique_items):
        """Sets the unique_items of this PropertyDefinition.


        :param unique_items: The unique_items of this PropertyDefinition.  # noqa: E501
        :type: bool
        """

        self._unique_items = unique_items

    @property
    def additional_properties(self):
        """Gets the additional_properties of this PropertyDefinition.  # noqa: E501


        :return: The additional_properties of this PropertyDefinition.  # noqa: E501
        :rtype: bool
        """
        return self._additional_properties

    @additional_properties.setter
    def additional_properties(self, additional_properties):
        """Sets the additional_properties of this PropertyDefinition.


        :param additional_properties: The additional_properties of this PropertyDefinition.  # noqa: E501
        :type: bool
        """

        self._additional_properties = additional_properties

    @property
    def required(self):
        """Gets the required of this PropertyDefinition.  # noqa: E501


        :return: The required of this PropertyDefinition.  # noqa: E501
        :rtype: list[str]
        """
        return self._required

    @required.setter
    def required(self, required):
        """Sets the required of this PropertyDefinition.


        :param required: The required of this PropertyDefinition.  # noqa: E501
        :type: list[str]
        """

        self._required = required

    @property
    def _not(self):
        """Gets the _not of this PropertyDefinition.  # noqa: E501


        :return: The _not of this PropertyDefinition.  # noqa: E501
        :rtype: PropertyDefinition
        """
        return self.__not

    @_not.setter
    def _not(self, _not):
        """Sets the _not of this PropertyDefinition.


        :param _not: The _not of this PropertyDefinition.  # noqa: E501
        :type: PropertyDefinition
        """

        self.__not = _not

    @property
    def any_of(self):
        """Gets the any_of of this PropertyDefinition.  # noqa: E501


        :return: The any_of of this PropertyDefinition.  # noqa: E501
        :rtype: list[PropertyDefinition]
        """
        return self._any_of

    @any_of.setter
    def any_of(self, any_of):
        """Sets the any_of of this PropertyDefinition.


        :param any_of: The any_of of this PropertyDefinition.  # noqa: E501
        :type: list[PropertyDefinition]
        """

        self._any_of = any_of

    @property
    def one_of(self):
        """Gets the one_of of this PropertyDefinition.  # noqa: E501


        :return: The one_of of this PropertyDefinition.  # noqa: E501
        :rtype: list[PropertyDefinition]
        """
        return self._one_of

    @one_of.setter
    def one_of(self, one_of):
        """Sets the one_of of this PropertyDefinition.


        :param one_of: The one_of of this PropertyDefinition.  # noqa: E501
        :type: list[PropertyDefinition]
        """

        self._one_of = one_of

    @property
    def all_of(self):
        """Gets the all_of of this PropertyDefinition.  # noqa: E501


        :return: The all_of of this PropertyDefinition.  # noqa: E501
        :rtype: list[PropertyDefinition]
        """
        return self._all_of

    @all_of.setter
    def all_of(self, all_of):
        """Sets the all_of of this PropertyDefinition.


        :param all_of: The all_of of this PropertyDefinition.  # noqa: E501
        :type: list[PropertyDefinition]
        """

        self._all_of = all_of

    @property
    def dependencies(self):
        """Gets the dependencies of this PropertyDefinition.  # noqa: E501


        :return: The dependencies of this PropertyDefinition.  # noqa: E501
        :rtype: dict(str, list[str])
        """
        return self._dependencies

    @dependencies.setter
    def dependencies(self, dependencies):
        """Sets the dependencies of this PropertyDefinition.


        :param dependencies: The dependencies of this PropertyDefinition.  # noqa: E501
        :type: dict(str, list[str])
        """

        self._dependencies = dependencies

    @property
    def pattern(self):
        """Gets the pattern of this PropertyDefinition.  # noqa: E501


        :return: The pattern of this PropertyDefinition.  # noqa: E501
        :rtype: str
        """
        return self._pattern

    @pattern.setter
    def pattern(self, pattern):
        """Sets the pattern of this PropertyDefinition.


        :param pattern: The pattern of this PropertyDefinition.  # noqa: E501
        :type: str
        """

        self._pattern = pattern

    @property
    def max_length(self):
        """Gets the max_length of this PropertyDefinition.  # noqa: E501


        :return: The max_length of this PropertyDefinition.  # noqa: E501
        :rtype: int
        """
        return self._max_length

    @max_length.setter
    def max_length(self, max_length):
        """Sets the max_length of this PropertyDefinition.


        :param max_length: The max_length of this PropertyDefinition.  # noqa: E501
        :type: int
        """

        self._max_length = max_length

    @property
    def min_length(self):
        """Gets the min_length of this PropertyDefinition.  # noqa: E501


        :return: The min_length of this PropertyDefinition.  # noqa: E501
        :rtype: int
        """
        return self._min_length

    @min_length.setter
    def min_length(self, min_length):
        """Sets the min_length of this PropertyDefinition.


        :param min_length: The min_length of this PropertyDefinition.  # noqa: E501
        :type: int
        """

        self._min_length = min_length

    @property
    def title(self):
        """Gets the title of this PropertyDefinition.  # noqa: E501


        :return: The title of this PropertyDefinition.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this PropertyDefinition.


        :param title: The title of this PropertyDefinition.  # noqa: E501
        :type: str
        """

        self._title = title

    @property
    def description(self):
        """Gets the description of this PropertyDefinition.  # noqa: E501


        :return: The description of this PropertyDefinition.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this PropertyDefinition.


        :param description: The description of this PropertyDefinition.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def properties(self):
        """Gets the properties of this PropertyDefinition.  # noqa: E501


        :return: The properties of this PropertyDefinition.  # noqa: E501
        :rtype: dict(str, PropertyDefinition)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this PropertyDefinition.


        :param properties: The properties of this PropertyDefinition.  # noqa: E501
        :type: dict(str, PropertyDefinition)
        """

        self._properties = properties

    @property
    def metadata(self):
        """Gets the metadata of this PropertyDefinition.  # noqa: E501


        :return: The metadata of this PropertyDefinition.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this PropertyDefinition.


        :param metadata: The metadata of this PropertyDefinition.  # noqa: E501
        :type: dict(str, object)
        """

        self._metadata = metadata

    @property
    def default(self):
        """Gets the default of this PropertyDefinition.  # noqa: E501


        :return: The default of this PropertyDefinition.  # noqa: E501
        :rtype: object
        """
        return self._default

    @default.setter
    def default(self, default):
        """Sets the default of this PropertyDefinition.


        :param default: The default of this PropertyDefinition.  # noqa: E501
        :type: object
        """

        self._default = default

    @property
    def const(self):
        """Gets the const of this PropertyDefinition.  # noqa: E501


        :return: The const of this PropertyDefinition.  # noqa: E501
        :rtype: object
        """
        return self._const

    @const.setter
    def const(self, const):
        """Sets the const of this PropertyDefinition.


        :param const: The const of this PropertyDefinition.  # noqa: E501
        :type: object
        """

        self._const = const

    @property
    def ref(self):
        """Gets the ref of this PropertyDefinition.  # noqa: E501


        :return: The ref of this PropertyDefinition.  # noqa: E501
        :rtype: str
        """
        return self._ref

    @ref.setter
    def ref(self, ref):
        """Sets the ref of this PropertyDefinition.


        :param ref: The ref of this PropertyDefinition.  # noqa: E501
        :type: str
        """

        self._ref = ref

    @property
    def data(self):
        """Gets the data of this PropertyDefinition.  # noqa: E501


        :return: The data of this PropertyDefinition.  # noqa: E501
        :rtype: str
        """
        return self._data

    @data.setter
    def data(self, data):
        """Sets the data of this PropertyDefinition.


        :param data: The data of this PropertyDefinition.  # noqa: E501
        :type: str
        """

        self._data = data

    @property
    def dynamic_default(self):
        """Gets the dynamic_default of this PropertyDefinition.  # noqa: E501


        :return: The dynamic_default of this PropertyDefinition.  # noqa: E501
        :rtype: str
        """
        return self._dynamic_default

    @dynamic_default.setter
    def dynamic_default(self, dynamic_default):
        """Sets the dynamic_default of this PropertyDefinition.


        :param dynamic_default: The dynamic_default of this PropertyDefinition.  # noqa: E501
        :type: str
        """

        self._dynamic_default = dynamic_default

    @property
    def enum(self):
        """Gets the enum of this PropertyDefinition.  # noqa: E501


        :return: The enum of this PropertyDefinition.  # noqa: E501
        :rtype: list[object]
        """
        return self._enum

    @enum.setter
    def enum(self, enum):
        """Sets the enum of this PropertyDefinition.


        :param enum: The enum of this PropertyDefinition.  # noqa: E501
        :type: list[object]
        """

        self._enum = enum

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PropertyDefinition, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PropertyDefinition):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
